/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.JPanel;

/**
 *
 * @author Administrator
 */
public class GamePanel extends Panel implements Runnable, KeyListener{

    public int width;
    public int heigth;
    public int incre=1;
    private Image im;
    private Graphics dbg;
    public Thread gamethread;
    private int fps;
    private boolean running = false;
    private boolean isPaused = false;
    private int direction;
    public static final int SOUTH = 0;
    public static final int NORTH = 1;
    public static final int EAST = 2;
    public static final int WEST = 3;
    private Snake sk;
    private Food bk;

    public GamePanel() {
        fps = 30;
        width = 400;
        heigth = 400;
        setPreferredSize(new Dimension(width, heigth));

        sk = new Snake(this);
        bk = new Food(this, sk);
        // 
        addKeyListener(this);
        setFocusable(true);
        requestFocus();

    }

    public void setPause(boolean b){
        isPaused=b;
    }
    
    public int getDirection() {
        return direction;
    }

    public void gameStart() {
        if (!running) {
            if(gamethread==null){
                gamethread = new Thread(this);
                gamethread.start();
            }
        }
    }

    public void gameStop() {
        running = false;
    }

    public void gamePaint() {
        Graphics g;
        try {
            g = this.getGraphics();
            if (g != null && im != null) {
                g.drawImage(im, 0, 0, null);
            }
            g.dispose();
        } catch (Exception e) {
        }
    }

    public void gameRender() {
        if (im == null) {
            im = createImage(width, heigth);
            if (im == null) {
                System.out.println("im is null");
            } else {
                dbg = im.getGraphics();
            }
        }

        dbg.setColor(Color.white);
        dbg.fillRect(0, 0, width, heigth);
        sk.draw(dbg);
        bk.draw(dbg);

    }

    public void gameUpdate() {

        if (!isPaused) {
            sk.update();
            bk.update();

        }
    }

    public void run() {
        long t1,t2,dt,sleepTime;  
        long period=1000/fps;  
        t1=System.nanoTime(); 

        running = true;
        while (running) {
            gameUpdate();
            gameRender();
            gamePaint();
            t2= System.nanoTime() ; 
            dt=(t2-t1)/1000000L; 
            sleepTime = period - dt;
            if(sleepTime<=0)        
                sleepTime=2;
            try {     
                Thread.sleep(sleepTime); 
            } catch (InterruptedException ex) { }
            t1 = System.nanoTime();  
        }
    }

    public void keyTyped(KeyEvent e) {
    }

    public void keyPressed(KeyEvent e) {
        int keycode = e.getKeyCode();

        if (!isPaused && running) {
            switch (keycode) {

                case KeyEvent.VK_DOWN:
                direction = SOUTH;
                //                     System.out.println("key is down" + direction);
                break;
                case KeyEvent.VK_UP:
                direction = NORTH;
                //                     System.out.println("key is up" + direction);
                break;
                case KeyEvent.VK_RIGHT:
                direction = EAST;
                //                     System.out.println("key is right" + direction);
                break;
                case KeyEvent.VK_LEFT:
                direction = WEST;
                //                     System.out.println("key is left" + direction);
                break;
            }
        }
    }

    public void keyReleased(KeyEvent e) {
    }
}

